package com.example.root.boxe;

import android.content.Context;
import android.graphics.Color;
import android.os.Environment;
import android.util.Log;
import android.view.View;

import org.achartengine.ChartFactory;
import org.achartengine.GraphicalView;
import org.achartengine.model.TimeSeries;
import org.achartengine.model.XYMultipleSeriesDataset;
import org.achartengine.model.XYSeries;
import org.achartengine.renderer.XYMultipleSeriesRenderer;
import org.achartengine.renderer.XYSeriesRenderer;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.IOException;
import java.text.DateFormat;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

public class MyGraph {

    private static final String TAG = "MyGraph";
    private String mDirectory="Boxe";
    String mFile = FileActivity.mFile;
    List<Integer> xvalues = new ArrayList<Integer>();
    List<Integer> yvalues = new ArrayList<Integer>();
    List<Integer> zvalues = new ArrayList<Integer>();
    List<Integer> tvalues = new ArrayList<Integer>();

    public void getView(Context context) {

        createTab2(mDirectory,mFile,xvalues,yvalues,zvalues,tvalues);

        for(int i=0;i<xvalues.size();i++){
            Log.d(TAG, "x = " + xvalues.get(i));
            Log.d(TAG, "y = " + yvalues.get(i));
            Log.d(TAG, "z = " + zvalues.get(i));
            Log.d(TAG, "t = " + tvalues.get(i));
        }
    }

    public void createTab2(String dir, String fileName, List<Integer> X, List<Integer> Y,List<Integer> Z,List<Integer> T) {

        File sdLien = Environment.getExternalStorageDirectory();
        System.out.println("sdlien file: "+sdLien.getPath().toString() );
        File myFile = new File(sdLien + File.separator + dir + File.separator + fileName);
        System.out.println("lien file: "+myFile.getPath().toString() );
        Log.d("Fichier SD", "path de fichier:" + myFile);
        if (!myFile.exists()) {
            throw new RuntimeException("Fichier innéxistant sur la cartesd");
        }
        BufferedReader reader = null;
        try {
            // Récupération du contenu du fichier dans un BufferedReader
            reader = new BufferedReader(new FileReader(myFile));
            String line;
            //valeur courante
            int x,y,z,t;
            int nb=0;
            // Parcours du bufferReader et intégration dans un String
            while ((line = reader.readLine()) != null) { //tant qu'on est pas a la derniere ligne
                String[] tokens = line.split(";"); //on découpe la ligne en morceaux et on les range dans un tableau tokens
                System.out.println("test tokens : "+tokens);
                x = Integer.parseInt(tokens[0]);
                y = Integer.parseInt(tokens[1]);
                z = Integer.parseInt(tokens[2]);
                t = Integer.parseInt(tokens[3]);
                System.out.println("test xyzt : "+x+" "+y+" "+z+" "+t);
                X.add(x);
                Y.add(y);
                Z.add(z);
                T.add(t);
                nb++;
            }
            System.out.println("val nb : "+nb);
        } catch (Exception e) {
            e.printStackTrace();
        } finally {
            if (reader != null) {
                try { //libération de la ressource
                    reader.close();
                } catch (IOException e) {
                    e.printStackTrace();
                }
            }
        }

    }


}
